#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>

/*Ağ adınızı ve Şifrenizi Giriniz*/
const char* kablosuzAgAdi = "ZyXEL";  // Ağ adınızı girin
const char* sifre = "CK4YTTFPACTL";  //Ağ şifrenizi girin

ESP8266WebServer server(80); //80 portunu kullanarak bir webserver nesnesi oluşturduk

bool odaDurum[8];
byte odaPin[] = {16, 5,  4, 0,  2,  14,  12,  13}; // D0 - D7 GPIO pin numaraları.
byte oda[8];
byte no;

void setup() {
  Serial.begin(9600);
  delay(100);
  for (byte i = 0; i < 8; i++)
    pinMode(odaPin[i], OUTPUT);


  Serial.println(kablosuzAgAdi);
  Serial.println(" Ağına Bağlanılıyor");

  //yerel ağınıza bağlanmanız için gerekli komut
  WiFi.begin(kablosuzAgAdi, sifre);

  //bağlantının gerçekleştiğini kontrol ediyoruz
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.print("."); //gerçekleşene kadar loading gibi işaret yaptırıyoruz
  }
  Serial.println("");
  Serial.println("Ağ Bağlantısı Sağlandı..!");
  Serial.print("IP Adresiniz: ");  Serial.println(WiFi.localIP());

  server.on("/", bagli);
  //  server.on("/led1on", LED1acik);
  //  server.on("/led1off", LED1kapali);
  //  server.on("/led2on", LED2acik);
  //  server.on("/led2off", LED2kapali);
  server.onNotFound(sayfaBulunamadi);

  server.begin();
  Serial.println("HTTP Sunucusu Başlatıldı");
}
void loop() {
  server.handleClient(); // İstemciden gelen verileri işle.
  for (byte i = 0; i < 8; i++) {
    if (odaDurum[i])
      digitalWrite(odaPin[i], HIGH);
    else
      digitalWrite(odaPin[i], LOW);
  }
}

void bagli() {
  for (byte i = 0; i < 8; i++) {
    //  odaDurum[i] = LOW;
    //  Serial.print(odaPin[i]);
    //  Serial.println(". Durumu: KAPALI");
    server.send(200, "text/html", HTML(&oda[i], &odaDurum[i]));
  }
}
//void led1on() {
//  LED1durum = LOW; // NodeMCU 1.0 (ESP-12E) D4 pini. Dahili LED aktif 0'dır.
//  Serial.println("GPIO7 Durumu: AÇIK");
//  server.send(200, "text/html", HTML(true, LED2durum));
//}
//void led1off() {
//  LED1durum = HIGH;
//  Serial.println("GPIO7 Durumu: KAPALI");
//  server.send(200, "text/html", HTML(false, LED2durum));
//}
//
//
//void LED1acik() {
//  LED1durum = HIGH;
//  Serial.println("GPIO7 Durumu: AÇIK");
//  server.send(200, "text/html", HTML(true, LED2durum));
//}
//
//void LED1kapali() {
//  LED1durum = LOW;
//  Serial.println("GPIO7 Durumu: KAPALI");
//  server.send(200, "text/html", HTML(false, LED2durum));
//}
//
//void LED2acik() {
//  LED2durum = HIGH;
//  Serial.println("GPIO6 Durumu: AÇIK");
//  server.send(200, "text/html", HTML(LED1durum, true));
//}
//
//void LED2kapali() {
//  LED2durum = LOW;
//  Serial.println("GPIO6 Durumu: KAPALI");
//  server.send(200, "text/html", HTML(LED1durum, false));
//}

void sayfaBulunamadi() {
  server.send(404, "text/plain", "Sayfa Bulunamadi.");
}

String HTML(byte oda[], bool odaDurum[]) {
  String metin = "<!DOCTYPE html> <html>\n";
  metin += "<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no\">\n";
  metin += "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=UTF-8\">";
  metin += "<title>LED ve Röle Kontrol</title>\n";
  metin += "<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}\n";
  metin += "body{margin-top: 50px;} h1 {color: #444444;margin: 50px auto 30px;} h3 {color: #444444;margin-bottom: 50px;}\n";
  metin += ".button {display: block;width: 80px;background-color: #1abc9c;border: none;color: white;padding: 13px 30px;text-decoration: none;font-size: 25px;margin: 0px auto 35px;cursor: pointer;border-radius: 4px;}\n";
  metin += ".button-on {background-color: #1abc9c;}\n";
  metin += ".button-on:active {background-color: #16a085;}\n";
  metin += ".button-off {background-color: #34495e;}\n";
  metin += ".button-off:active {background-color: #2c3e50;}\n";
  metin += "p {font-size: 14px;color: #888;margin-bottom: 10px;}\n";
  metin += "</style>\n";
  metin += "</head>\n";
  metin += "<body>\n";
  metin += "<h1>ESP8266 Web Server Uygulaması</h1>\n";
  metin += "<h3>ESP Station(STA) Modunda Kullanılıyor</h3>\n";

  for (no = 0; no < 8; no++) {
    if (odaDurum[no])
      metin += oda[no] + "<p> Durum: AÇIK</p><a class=\"button button-off\" href=oda[no] >KAPAT</a>\n";
    else
      metin += oda[no] + "<p> Durum: KAPALI</p><a class=\"button button-on\" href=oda[no] >AÇ</a>\n";
  }

  metin += "</body>\n";
  metin += "</html>\n";
  return metin;
}
